;=====i2c lcd test for Ericsson GA628 / Version 2.0======21/06/03==
;iic lcd driver: PCF2103
;ra0,ra1     sdata,sclock
;rb0 to rb7led outputs
;internal clock
;standard crystal 4.000 MHz XT - 1us pe instructiune
;Program realizat de Ing. Bergthaller Iulian-Alexandru 
;------------------------------------------------------------
listp=16f84A;f=inhx8m
_CP_OFFequH'3FFF'      ;code protect off
_PWRTE_ONequH'3FFF' ;Power on timer on
_WDT_OFFequH'3FFB';watch dog timer off
_XT_OSCequH'3FFD';crystal oscillator
__CONFIG       _CP_OFF & _PWRTE_ON & _WDT_OFF & _XT_OSC
;------------------------------------------------------------
;      cpu init
statusequ03
portaequ05
portbequ06
count1equ0C
count2equ0D
count3equ0E
transoequ0F
trisaequ85
trisbequ86
#DEFINE sclkporta,1
#DEFINE sdtaporta,0
;------------------------------------------------------------
;      bit init
rp0equ5
wequ0
fequ1
;------------------------------------------------------------
org0
;
;------------------------------------------------------------
initbsfstatus,rp0  ;switch to bank 1
movlw0; porta and portb set to outputs
movwftrisa
movwftrisb
bcfstatus,rp0  ;switch back to bank 0
movlw0
movwfporta
movwfportb
;***************************************************
startmovlw0xFF; led test
movwfportb 
callpause
;***************************************************
;* Lcd init commands                               *
;***************************************************
scriecalliict; i2c start
movlw0x74; device write address (75h for read)
callact; i2c send subroutine
movlw0x00; Co,RS=0, set instruction register for multiple next command bytes  
callact
movlw0x31; extended instruction set
callact
movlw0x02; set screen configuration left to right 
callact
movlw0x05; set display configuration 
callact
movlw0x08; set icon mode, full mode, icon blink disable
callact
movlw0x30; normal instruction set
callact
movlw0x0C; set display on
callact
movlw0x06; set cursor move direction
callact
movlw0x02; set DDRAM address 0 in address counter
callact
calliicp; i2c stop 
;***************************************************
;* Lcd icon sets off                               *
;***************************************************
calliict
movlw0x74
callact
movlw0x80; Co=1, RS=0 just one next command byte
callact
movlw0x4C; set CGRAM for icons
callact
movlw0x40; Co=0, RS=1, set instruction register for multiple next data bytes  
callact
movlw0x00; erase icons sequence
callact
movlw0x18
callact
movlw0x00
callact
movlw0x00
callact
movlw0x00
callact
movlw0x00
callact
movlw0x00
callact
movlw0x00
callact
movlw0x00
callact
movlw0x00
callact
movlw0x00
callact
movlw0x00
callact
movlw0x0F
callact
movlw0x10
callact
calliicp; i2c stop 
;***************************************************
;* Lcd cursor subroutine                           *
;***************************************************
calliict
movlw0x74
callact
movlw0x00
callact
movlw0x30
callact
movlw0x01; clears entire display and sets DDRAM address to 0 in address counter
callact
movlw0x0F; display on, cursor on, cursor blink on
callact
calliicp
;***************************************************
;* Lcd data subroutine                             *
;***************************************************
calliict
movlw0x74
callact
movlw0x80; Co=1, RS=0 just one next command byte
callact
movlw0x8C; set CGRAM for characters
callact
movlw0x40; Co=0, RS=1, set instruction register for multiple next data bytes  
callact
movlw0xC8; H
callact
movlw0xE5; e
callact
movlw0xEC; l
callact
movlw0xEC; l
callact
movlw0xEF; o
callact
movlw0x20;  
callact
movlw0xD7; W
callact
movlw0xEF; o
callact
movlw0xF2; r
callact
movlw0xEC; l
callact
movlw0xE4; d
callact
calliicp
homagotohoma
;***************************************************
actmovwftranso; iic data transmission 
calloled
movlw0x08
movwfcount3
vbitbcfsclk
callpause
btfsctranso,7
bsfsdta
btfsstranso,7
bcfsdta
callpause
bsfsclk
callpause
bcfsclk
callpause
rlftranso,f
decfszcount3,f
gotovbit
callackp
retlw00
;***************************************************
iicpbcfsdta; stop condition module
callpause
bsfsclk
callpause
bsfsdta; stop command
callpause
bcfsclk
callpause
retlw00
;***************************************************
iictbsfsdta; start condition module 
bsfsclk
callpause
bcfsdta; start command
callpause
bcfsclk
callpause
retlw00
;***************************************************
ackpbsfsclk; one clock step for acknowledge (not read)
callpause
bcfsclk
callpause
retlw00
;***************************************************
oledcallhalta; iic data before transmission displayed on portb
movlw0x00
movwfportb 
movftranso,w
movwfportb
callhalta
movlw0x00
movwfportb
retlw00
;***************************************************
pausemovlw0x08; cca. 6ms delay
movwfcount1
d1movlw0xFF  
movwfcount2
d2decfszcount2,f
goto d2
decfszcount1,f
goto d1
 retlw00
;***************************************************
haltamovlw0x03; cca. 585ms delay
movwfcount3
r3movlw0xFF
movwfcount1
r1movlw0xFF  
movwfcount2
r2decfszcount2,f
goto r2
decfszcount1,f
goto r1
decfszcount3,f    
goto r3          
retlw00
;------------------------------------------------------------
end
;============================================================